//+------------------------------------------------------------------+
//|                                 Fib_Pivots_TimeShift_History.mq4 |
//+------------------------------------------------------------------+
#property link      "Code modified by cja"

#property indicator_chart_window
//---- input parameters
extern int   CountDays      =50;
extern int   GMT_Shift      =0;

extern color R3_color       =Red;
extern color R2_color       =Yellow;
extern color R1_color       =Lime;
extern color Pivot_color    = White;
extern color S1_color       =Lime;
extern color S2_color       =Yellow;
extern color S3_color       =Red;
extern int   S_R_Style      = 0; 
extern int   S_R_Width      = 2;   
extern bool  Show_MidLevels = true;  
extern color Mid_Color      = Gray;
extern int   Mid_Style      = 2; 
extern int   Mid_Width      = 0;  

extern string Font          = "Tahoma Narrow";
extern int   Fontsize       = 9; 

//---- indicator buffers
double range[];
double timeshift[];
double low[];
double high[];
datetime time1;
datetime time2;
datetime start_time[];

int shift, num;
int ny_shift[];
datetime prevDay=0;
bool fTime;
// ----
void ObjDel()
{
   if (ObjectsTotal() > 0)
   for (num=0;num<=CountDays;num++)
   {
   ObjectDelete("PP["+num+"]");
   
   ObjectDelete("R3["+num+"]");
   ObjectDelete("R2["+num+"]");
   ObjectDelete("R1["+num+"]");
   
   ObjectDelete("S1["+num+"]");
   ObjectDelete("S2["+num+"]");
   ObjectDelete("S3["+num+"]");
   
   
   ObjectDelete("m0["+num+"]");
   ObjectDelete("m1["+num+"]");
   ObjectDelete("m2["+num+"]");
   ObjectDelete("m3["+num+"]");
   ObjectDelete("m4["+num+"]");
   ObjectDelete("m5["+num+"]");
   }
   ObjectDelete("mP");
   
   ObjectDelete("mR3");
   ObjectDelete("mR2");
   ObjectDelete("mR1");
   ObjectDelete("mS1"); 
   ObjectDelete("mS2");
   ObjectDelete("mS3");
     
   ObjectDelete("mm0");
   ObjectDelete("mm1");
   ObjectDelete("mm2");
   ObjectDelete("mm3");
   ObjectDelete("mm4");
   ObjectDelete("mm5"); 
   }
// ----
void PlotLine(string name,double value,double value1,double line_color,double style,double width)
{
   double valueN=NormalizeDouble(value,Digits);
   double valueN1=NormalizeDouble(value1,Digits);
   bool res = ObjectCreate(name,OBJ_TREND,0,time1,valueN,time2,valueN1);
   ObjectSet(name, OBJPROP_WIDTH, width);
   ObjectSet(name, OBJPROP_STYLE, style);
   ObjectSet(name, OBJPROP_RAY, false);
   ObjectSet(name, OBJPROP_BACK, true);
   ObjectSet(name, OBJPROP_COLOR, line_color);
} 
//***********
void PlotPrice(string name,string LabelText, int FontSize, string FontName, double value, double line_color)
{
    double valueN=NormalizeDouble(value,Digits);
    bool res = ObjectCreate(name, OBJ_TEXT, 0, time1,valueN);
    ObjectSetText(name, LabelText, FontSize, FontName, line_color);
   }  

         
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   fTime = true;
   IndicatorBuffers(2);
   SetIndexBuffer(0,range);
   SetIndexBuffer(1,timeshift);
   return(0);
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+   
int deinit()
{
   ObjDel();
  
   return(0);
}
//+------------------------------------------------------------------+
//| LNX_Pivots_v3.1                                                    |
//+------------------------------------------------------------------+
int start()
{
   int i;
   double P,R1,R2,R3,R4,S1,S2,S3,S4;
  
   datetime cDay = iTime(NULL,PERIOD_D1,0) + (GMT_Shift-Period()/60.0)*3600;
   if (cDay != prevDay || fTime)  
   {
   ObjDel();
   ArrayResize(start_time,CountDays+1);
   ArrayResize(ny_shift,CountDays+1);
   ArrayResize(high,CountDays+1);
   ArrayResize(low,CountDays+1); 
   ArrayResize(range,CountDays+1);    
      for (shift=0;shift<=CountDays;shift++)
      {
      start_time[shift]  = iTime(NULL,PERIOD_D1,shift) + (GMT_Shift-Period()/60.0)*3600;
      ny_shift[shift] = iBarShift(NULL,0,start_time[shift]);
      timeshift[shift] = iClose(NULL,0,ny_shift[shift]);        
      }
     
      for (shift=0;shift<=CountDays-1;shift++)
      {
      int length = ny_shift[shift+1]-ny_shift[shift];
     
      high[shift] = High[iHighest(NULL,0,MODE_HIGH,length,ny_shift[shift])];
      low[shift]  = Low[iLowest(NULL,0,MODE_LOW,length,ny_shift[shift])];
      range[shift] = high[shift] - low[shift]; 
      }
  
      for (shift=0;shift<=CountDays-1;shift++)
      {
  
      P  = (timeshift[shift]+high[shift]+low[shift])/3;

      time1 = start_time[shift]+Period()*60;    
         
         if (shift==0) 
         {
         time2 = start_time[shift] + 24*3600+Period()*60 ;
         PlotPrice("mP","Pivot",Fontsize,Font,P,Pivot_color);
         PlotPrice("mR3","R3",Fontsize,Font,P+(range[shift]* 0.99),R3_color);
         PlotPrice("mR2","R2",Fontsize,Font,P+(range[shift]* 0.618),R2_color);
         PlotPrice("mR1","R1",Fontsize,Font,P+(range[shift]* 0.382),R1_color);
         
         PlotPrice("mS1","S1",Fontsize,Font,P-(range[shift]* 0.382),S1_color);
         PlotPrice("mS2","S2",Fontsize,Font,P-(range[shift]* 0.618),S2_color);
         PlotPrice("mS3","S3",Fontsize,Font,P-(range[shift]* 0.99),S3_color);
        
         if(Show_MidLevels){   
         PlotPrice("mm0","m0",Fontsize,Font,P-(range[shift]* 0.804),Mid_Color);
         PlotPrice("mm1","m1",Fontsize,Font,P-(range[shift]* 0.500),Mid_Color);
         PlotPrice("mm2","m2",Fontsize,Font,P-(range[shift]* 0.191),Mid_Color);
         PlotPrice("mm3","m3",Fontsize,Font,P+(range[shift]* 0.191),Mid_Color);
         PlotPrice("mm4","m4",Fontsize,Font,P+(range[shift]* 0.500),Mid_Color);
         PlotPrice("mm5","m5",Fontsize,Font,P+(range[shift]* 0.804),Mid_Color);      
         }}
         else
         time2 = start_time[shift-1]+Period()*60;
   
   
   PlotLine("PP["+shift+"]",P,P,White,S_R_Style,S_R_Width);
   PlotLine("R3["+shift+"]",P+(range[shift]* 0.99),P+(range[shift]* 0.99),R3_color,S_R_Style,S_R_Width);
   PlotLine("R2["+shift+"]",P+(range[shift]* 0.618), P+(range[shift]* 0.618),R2_color,S_R_Style,S_R_Width);
   PlotLine("R1["+shift+"]",P+(range[shift]* 0.382), P+(range[shift]* 0.382),R1_color,S_R_Style,S_R_Width);
   PlotLine("S1["+shift+"]",P-(range[shift]* 0.382), P-(range[shift]* 0.382),S1_color,S_R_Style,S_R_Width);
   PlotLine("S2["+shift+"]",P-(range[shift]* 0.618), P-(range[shift]* 0.618),S2_color,S_R_Style,S_R_Width);
   PlotLine("S3["+shift+"]",P-(range[shift]* 0.99), P-(range[shift]* 0.99),S3_color,S_R_Style,S_R_Width);
   
   if(Show_MidLevels){
   PlotLine("m0["+shift+"]",P-(range[shift]* 0.804),P-(range[shift]* 0.804),Mid_Color,Mid_Style,Mid_Width);
   PlotLine("m1["+shift+"]",P+(range[shift]* 0.804),P+(range[shift]* 0.804),Mid_Color,Mid_Style,Mid_Width);
   PlotLine("m2["+shift+"]",P-(range[shift]* 0.500),P-(range[shift]* 0.500),Mid_Color,Mid_Style,Mid_Width);
   PlotLine("m3["+shift+"]",P+(range[shift]* 0.500),P+(range[shift]* 0.500),Mid_Color,Mid_Style,Mid_Width);
   PlotLine("m4["+shift+"]",P-(range[shift]* 0.191),P-(range[shift]* 0.191),Mid_Color,Mid_Style,Mid_Width);
   PlotLine("m5["+shift+"]",P+(range[shift]* 0.191),P+(range[shift]* 0.191),Mid_Color,Mid_Style,Mid_Width);
   }
  
}
   fTime = false;
   prevDay = cDay;
   }      
        
   return(0);
}
//+------------------------------------------------------------------+